=== modified file 'bzr-notify'
--- bzr-notify	2011-07-31 16:50:29 +0000
+++ bzr-notify	2012-02-03 19:49:55 +0000
@@ -15,31 +15,36 @@
 Gtk = open_display()
 
 import cgi
+import sys
+
 import dbus
 import dbus.service
-import gobject
-import pynotify
+from gi.repository import GObject
+from gi.repository import Notify
+
 from bzrlib.bzrdir import BzrDir
 from bzrlib.osutils import format_date
 from bzrlib.transport import get_transport
 
 menu = NotifyPopupMenu()
 try:
-    import appindicator
+    from gi.repository import AppIndicator3
 except ImportError:
-    icon = gtk.status_icon_new_from_icon_name("bzr-panel")
+    icon = Gtk.StatusIcon.new_from_icon_name("bzr-panel")
     icon.connect('popup-menu', menu.display)
     icon.set_visible(False)
     hide_icon = lambda: icon.set_visible(False)
     show_icon = lambda: icon.set_visible(True)
 else:
-    indicator = appindicator.Indicator ("bzr-gtk-notify",
-        "bzr-panel", appindicator.CATEGORY_OTHER)
-    indicator.set_status (appindicator.STATUS_PASSIVE)
+    indicator = AppIndicator3.Indicator.new(
+        "bzr-gtk-notify", "bzr-panel", AppIndicator3.IndicatorCategory.OTHER)
+    indicator.set_status (AppIndicator3.IndicatorStatus.PASSIVE)
     indicator.set_attention_icon("bzr-panel")
     indicator.set_menu(menu)
-    hide_icon = lambda: indicator.set_status (appindicator.STATUS_PASSIVE)
-    show_icon = lambda: indicator.set_status (appindicator.STATUS_ATTENTION)
+    hide_icon = lambda: indicator.set_status (
+        AppIndicator3.IndicatorStatus.PASSIVE)
+    show_icon = lambda: indicator.set_status (
+        AppIndicator3.IndicatorStatus.ATTENTION)
 
 if getattr(dbus, 'version', (0,0,0)) >= (0,41,0):
     import dbus.glib
@@ -64,7 +69,7 @@
         body += '\n'
         body += revision.message
         body = cgi.escape(body)
-        nw = pynotify.Notification(summary, body)
+        nw = Notify.Notification.new(summary, body, None)
         def start_viz(notification=None, action=None, data=None):
             """Start the viz program."""
             from bzrlib.plugins.gtk.commands import start_viz_window
@@ -75,11 +80,11 @@
             from bzrlib.plugins.gtk.branch import BranchDialog
             bd = BranchDialog(remote_path=url)
             bd.run()
-        if "actions" in pynotify.get_server_caps():
+        if "actions" in Notify.get_server_caps():
             nw.add_action("inspect", "Inspect", start_viz, None)
             nw.add_action("branch", "Branch", start_branch, None)
         show_icon()
-        gobject.timeout_add(5000, hide_icon)
+        GObject.timeout_add(5000, hide_icon)
         nw.set_timeout(5000)
         nw.show()
     except Exception, e:
@@ -88,5 +93,10 @@
 bus.add_signal_receiver(catch_branch,
                         dbus_interface=BROADCAST_INTERFACE,
                         signal_name="Revision")
-pynotify.init("bzr-notify")
-gtk.main()
+Notify.init("bzr-notify")
+
+if sys.argv[-1] == 'test':
+    # Exit before main loop.
+    sys.exit(0)
+
+Gtk.main()

=== modified file 'tests/test_notify.py'
--- tests/test_notify.py	2012-02-03 18:59:38 +0000
+++ tests/test_notify.py	2012-02-03 19:49:55 +0000
@@ -15,7 +15,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from gi.repository import Gtk
+import os
+import subprocess
 
 from bzrlib import tests
 from bzrlib.plugins.gtk.notify import NotifyPopupMenu
@@ -26,8 +27,6 @@
     SHOW_WIDGETS = False
 
 
-# ['_Gateway to LAN', '', 'Announce _branches on LAN', '', 'gtk-preferences', 'gtk-about', '', 'gtk-quit']
-
 class NotifyPopupMenuTestCase(tests.TestCase):
 
     def test_init(self):
@@ -39,3 +38,18 @@
         self.assertEqual('gtk-preferences', items[4].props.label)
         self.assertEqual('gtk-about', items[5].props.label)
         self.assertEqual('gtk-quit', items[7].props.label)
+
+
+class BzrNotifyTestCase(tests.TestCase):
+
+    def test_smoketest(self):
+        # This is a smoke test to verify the process starts.
+        # The logic of the module must be moved into notify.py
+        # where it can be properly tested.
+        script = os.path.join(
+            os.path.dirname(__file__), os.pardir, 'bzr-notify')
+        bzr_notify = subprocess.Popen(
+            [script, 'test'], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
+        stdout, stderr = bzr_notify.communicate()
+        self.assertEqual('', stdout)
+        self.assertEqual('', stderr)

